您的位置:首页 > 其它

Codeforces-Round-#363-Fix-a-Tree

2016-07-20 13:03 567 查看
Fix a Tree

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

A tree is an undirected connected graph without cycles.

Let's consider a rooted undirected tree with n vertices, numbered 1 through n.
There are many ways to represent such a tree. One way is to create an array with n integers p1, p2, ..., pn,
where pi denotes
a parent of vertex i (here, for convenience a root is considered its own parent).


For
this rooted tree the array p is [2, 3, 3, 2].

Given a sequence p1, p2, ..., pn,
one is able to restore a tree:

There must be exactly one index r that pr = r.
A vertex r is a root of the tree.

For all other n - 1 vertices i,
there is an edge between vertex i and vertex pi.

A sequence p1, p2, ..., pn is
called valid if the described procedure generates some (any) rooted tree. For example, for n = 3sequences (1,2,2), (2,3,1) and (2,1,3) are
not valid.

You are given a sequence a1, a2, ..., an,
not necessarily valid. Your task is to change the minimum number of elements, in order to get a valid sequence. Print the minimum number of changes and an example of a valid sequence after that number of changes. If there are many valid sequences achievable
in the minimum number of changes, print any of them.

Input

The first line of the input contains an integer n (2 ≤ n ≤ 200 000) —
the number of vertices in the tree.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n).

Output

In the first line print the minimum number of elements to change, in order to get a valid sequence.

In the second line, print any valid sequence possible to get from (a1, a2, ..., an) in
the minimum number of changes. If there are many such sequences, any of them will be accepted.

Examples

input
4
2 3 3 4


output
1
2 3 4 4


input
5
3 2 2 5 3


output
0
3 2 2 5 3


input
8
2 3 5 4 1 6 6 7


output
2
2 3 7 8 1 6 6 7


Note

In the first sample, it's enough to change one element. In the provided output, a sequence represents a tree rooted in a vertex 4(because p4 = 4),
which you can see on the left drawing below. One of other correct solutions would be a sequence 2 3 3 2, representing a tree rooted in vertex 3 (right
drawing below). On both drawings, roots are painted red.



In the second sample, the given sequence is already valid.

题意:按顺序给出n个节点的父节点编号,要求用最少的操作次数,把这个图变成树。

题目链接:Fix a Tree

解题思路:
清楚树的两个要求,1.不存在环,2.只有一个根。
因此可以用并查集把最优树的根确定下来,要操作修改的地方就是有 环  和 多个根 的情况,对于环的情况,也可以用并查集处理,直接把这个节点接到根上(答案不唯一)。
多个根情况也如此,也把这个节点接到根上。
用cnt 记录上述情况出现的次数,表示要操作的次数。

代码:

#include
#include
#include
#include
#include
#include
#include
#include
#include
#define si(x) scanf("%d",&x);
#define sii(x,y) scanf("%d%d",&x,&y);
#define siii(x,y,z) scanf("%d%d%d",&x,&y,&z);
#define rep(i,s,n) for(i = s;i <= n;i++)
#define dow(i,n,s) for(i = n;i >= s;i--)

using namespace std;
typedef long long LL;
const int N = 1e5 + 5;
int a[2 * N],fa[2 * N],root,n,cnt;

int find_fa(int x) //并查集的找根模板函数
{
return fa[x] == x?x:fa[x] = find_fa(fa[x]);
}
void init() //初始化
{
int i ;
rep(i,1,n) fa[i] = i;
root = -1;
cnt = 0;
}
int main()
{
int i;
while(~scanf("%d",&n)){
init();
rep(i,1,n){
si(a[i]);
if(i == a[i]) { //记录原序列根节点的个数,已经判断是否出现根
root = a[i],cnt ++;
}
else {
int f1 = find_fa(i),f2 = find_fa(a[i]); //寻找并查集中节点对应的根节点
if(f1 == f2) {  //成环的情况
a[i] = i,cnt ++;   //选取一个节点置为根

}
else fa[f1] = f2;   //不成环,则把其在并查集中的边连接
}
}
if(root == -1) {    //没出现根
rep(i,1,n) {
if(fa[i] == i) { //选用并查集中的根作为新树的根,保证树的连通
root = fa[i];
break;
}
}
cnt ++;     //多了一个根
}
printf("%d\n",cnt - 1); //有一个根是合法的
rep(i,1,n) {
if(a[i] == i) a[i] = root;  //根只能有一个
printf("%d%c",a[i],i == n?'\n':' ');
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息